<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>TIOVX Tutorials: vx_tutorial_image_color_convert.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<img src="ti_logo.gif">
<tr bgcolor="#CCCCCC"> 
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<!-- Generated by Doxygen 1.6.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
    </ul>
  </div>
<h1>vx_tutorial_image_color_convert.c</h1><a href="vx__tutorial__image__color__convert_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">*</span>
<a name="l00003"></a>00003 <span class="comment">* Copyright (c) 2017 Texas Instruments Incorporated</span>
<a name="l00004"></a>00004 <span class="comment">*</span>
<a name="l00005"></a>00005 <span class="comment">* All rights reserved not granted herein.</span>
<a name="l00006"></a>00006 <span class="comment">*</span>
<a name="l00007"></a>00007 <span class="comment">* Limited License.</span>
<a name="l00008"></a>00008 <span class="comment">*</span>
<a name="l00009"></a>00009 <span class="comment">* Texas Instruments Incorporated grants a world-wide, royalty-free, non-exclusive</span>
<a name="l00010"></a>00010 <span class="comment">* license under copyrights and patents it now or hereafter owns or controls to make,</span>
<a name="l00011"></a>00011 <span class="comment">* have made, use, import, offer to sell and sell (&quot;Utilize&quot;) this software subject to the</span>
<a name="l00012"></a>00012 <span class="comment">* terms herein.  With respect to the foregoing patent license, such license is granted</span>
<a name="l00013"></a>00013 <span class="comment">* solely to the extent that any such patent is necessary to Utilize the software alone.</span>
<a name="l00014"></a>00014 <span class="comment">* The patent license shall not apply to any combinations which include this software,</span>
<a name="l00015"></a>00015 <span class="comment">* other than combinations with devices manufactured by or for TI (&quot;TI Devices&quot;).</span>
<a name="l00016"></a>00016 <span class="comment">* No hardware patent is licensed hereunder.</span>
<a name="l00017"></a>00017 <span class="comment">*</span>
<a name="l00018"></a>00018 <span class="comment">* Redistributions must preserve existing copyright notices and reproduce this license</span>
<a name="l00019"></a>00019 <span class="comment">* (including the above copyright notice and the disclaimer and (if applicable) source</span>
<a name="l00020"></a>00020 <span class="comment">* code license limitations below) in the documentation and/or other materials provided</span>
<a name="l00021"></a>00021 <span class="comment">* with the distribution</span>
<a name="l00022"></a>00022 <span class="comment">*</span>
<a name="l00023"></a>00023 <span class="comment">* Redistribution and use in binary form, without modification, are permitted provided</span>
<a name="l00024"></a>00024 <span class="comment">* that the following conditions are met:</span>
<a name="l00025"></a>00025 <span class="comment">*</span>
<a name="l00026"></a>00026 <span class="comment">* *       No reverse engineering, decompilation, or disassembly of this software is</span>
<a name="l00027"></a>00027 <span class="comment">* permitted with respect to any software provided in binary form.</span>
<a name="l00028"></a>00028 <span class="comment">*</span>
<a name="l00029"></a>00029 <span class="comment">* *       any redistribution and use are licensed by TI for use only with TI Devices.</span>
<a name="l00030"></a>00030 <span class="comment">*</span>
<a name="l00031"></a>00031 <span class="comment">* *       Nothing shall obligate TI to provide you with source code for the software</span>
<a name="l00032"></a>00032 <span class="comment">* licensed and provided to you in object code.</span>
<a name="l00033"></a>00033 <span class="comment">*</span>
<a name="l00034"></a>00034 <span class="comment">* If software source code is provided to you, modification and redistribution of the</span>
<a name="l00035"></a>00035 <span class="comment">* source code are permitted provided that the following conditions are met:</span>
<a name="l00036"></a>00036 <span class="comment">*</span>
<a name="l00037"></a>00037 <span class="comment">* *       any redistribution and use of the source code, including any resulting derivative</span>
<a name="l00038"></a>00038 <span class="comment">* works, are licensed by TI for use only with TI Devices.</span>
<a name="l00039"></a>00039 <span class="comment">*</span>
<a name="l00040"></a>00040 <span class="comment">* *       any redistribution and use of any object code compiled from the source code</span>
<a name="l00041"></a>00041 <span class="comment">* and any resulting derivative works, are licensed by TI for use only with TI Devices.</span>
<a name="l00042"></a>00042 <span class="comment">*</span>
<a name="l00043"></a>00043 <span class="comment">* Neither the name of Texas Instruments Incorporated nor the names of its suppliers</span>
<a name="l00044"></a>00044 <span class="comment">*</span>
<a name="l00045"></a>00045 <span class="comment">* may be used to endorse or promote products derived from this software without</span>
<a name="l00046"></a>00046 <span class="comment">* specific prior written permission.</span>
<a name="l00047"></a>00047 <span class="comment">*</span>
<a name="l00048"></a>00048 <span class="comment">* DISCLAIMER.</span>
<a name="l00049"></a>00049 <span class="comment">*</span>
<a name="l00050"></a>00050 <span class="comment">* THIS SOFTWARE IS PROVIDED BY TI AND TI&apos;S LICENSORS &quot;AS IS&quot; AND ANY EXPRESS</span>
<a name="l00051"></a>00051 <span class="comment">* OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES</span>
<a name="l00052"></a>00052 <span class="comment">* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.</span>
<a name="l00053"></a>00053 <span class="comment">* IN NO EVENT SHALL TI AND TI&apos;S LICENSORS BE LIABLE FOR ANY DIRECT, INDIRECT,</span>
<a name="l00054"></a>00054 <span class="comment">* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,</span>
<a name="l00055"></a>00055 <span class="comment">* BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,</span>
<a name="l00056"></a>00056 <span class="comment">* DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY</span>
<a name="l00057"></a>00057 <span class="comment">* OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE</span>
<a name="l00058"></a>00058 <span class="comment">* OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED</span>
<a name="l00059"></a>00059 <span class="comment">* OF THE POSSIBILITY OF SUCH DAMAGE.</span>
<a name="l00060"></a>00060 <span class="comment">*</span>
<a name="l00061"></a>00061 <span class="comment">*/</span>
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00112"></a>00112 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00113"></a>00113 <span class="preprocessor">#include &lt;VX/vx.h&gt;</span>
<a name="l00114"></a>00114 <span class="preprocessor">#include &lt;<a class="code" href="utility_8h.html">utility.h</a>&gt;</span>
<a name="l00115"></a>00115 
<a name="l00117"></a><a class="code" href="vx__tutorial__image__color__convert_8c.html#a8118656bb5a60090a1dbffa402168438">00117</a> <span class="preprocessor">#define IN_FILE_NAME       &quot;colors.bmp&quot;</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>
<a name="l00120"></a><a class="code" href="vx__tutorial__image__color__convert_8c.html#a75506823f0db0ef3f4f022cf132dbbbb">00120</a> <span class="preprocessor">#define OUT_FILE_NAME      &quot;vx_tutorial_image_color_convert_out.bmp&quot;</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span>
<a name="l00125"></a><a class="code" href="vx__tutorial__image__color__convert_8c.html#ad2b8fd09b4afa65ad14e89f0a9513f11">00125</a> <span class="keywordtype">void</span> <a class="code" href="vx__tutorial__image__color__convert_8c.html#ad2b8fd09b4afa65ad14e89f0a9513f11" title="Tutorial Entry Point.">vx_tutorial_image_color_convert</a>()
<a name="l00126"></a>00126 {
<a name="l00134"></a>00134     vx_context context;
<a name="l00135"></a>00135     vx_image rgb_image = NULL;
<a name="l00136"></a>00136     vx_image nv12_image = NULL;
<a name="l00137"></a>00137     vx_image y_image = NULL;
<a name="l00138"></a>00138     vx_node node0 = NULL, node1 = NULL;
<a name="l00139"></a>00139     vx_graph graph = NULL;
<a name="l00141"></a>00141     vx_uint32 width, height;
<a name="l00142"></a>00142     vx_status status;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     printf(<span class="stringliteral">&quot; vx_tutorial_image_color_convert: Tutorial Started !!! \n&quot;</span>);
<a name="l00145"></a>00145 
<a name="l00153"></a>00153     context = vxCreateContext();
<a name="l00156"></a>00156     printf(<span class="stringliteral">&quot; Loading file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>);
<a name="l00157"></a>00157 
<a name="l00163"></a>00163     graph = vxCreateGraph(context);
<a name="l00165"></a>00165     vxSetReferenceName((vx_reference)graph, <span class="stringliteral">&quot;MY_GRAPH&quot;</span>);
<a name="l00166"></a>00166 
<a name="l00174"></a>00174     rgb_image = <a class="code" href="utility_8h.html#af8e9cbbd49ab0dec7850267224548cd6" title="Create a image data object given BMP filename as input.">create_image_from_file</a>(context, <a class="code" href="vx__tutorial__image__load__save_8c.html#a8118656bb5a60090a1dbffa402168438" title="Input file name.">IN_FILE_NAME</a>, vx_false_e);
<a name="l00177"></a>00177     vxSetReferenceName((vx_reference)rgb_image, <span class="stringliteral">&quot;RGB_IMAGE&quot;</span>);
<a name="l00178"></a>00178 
<a name="l00186"></a>00186     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(rgb_image);
<a name="l00189"></a>00189     vxQueryImage(rgb_image, VX_IMAGE_WIDTH, &amp;width, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00190"></a>00190     vxQueryImage(rgb_image, VX_IMAGE_HEIGHT, &amp;height, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00191"></a>00191 
<a name="l00201"></a>00201     nv12_image = vxCreateVirtualImage(graph, 0, 0, VX_DF_IMAGE_NV12);
<a name="l00203"></a>00203     vxSetReferenceName((vx_reference)nv12_image, <span class="stringliteral">&quot;NV12_IMAGE&quot;</span>);
<a name="l00211"></a>00211     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(nv12_image);
<a name="l00221"></a>00221     y_image = vxCreateImage(context, width, height, VX_DF_IMAGE_U8);
<a name="l00223"></a>00223     vxSetReferenceName((vx_reference)y_image, <span class="stringliteral">&quot;Y_IMAGE&quot;</span>);
<a name="l00224"></a>00224     <a class="code" href="utility_8h.html#ade45042efce712b30cf8254a6c90b3bc" title="Show attributes of previously created image.">show_image_attributes</a>(y_image);
<a name="l00225"></a>00225 
<a name="l00234"></a>00234     node0 = vxColorConvertNode(graph, rgb_image, nv12_image);
<a name="l00236"></a>00236     vxSetReferenceName((vx_reference)node0, <span class="stringliteral">&quot;COLOR_CONVERT&quot;</span>);
<a name="l00237"></a>00237 
<a name="l00247"></a>00247     node1 = vxChannelExtractNode(graph, nv12_image, VX_CHANNEL_Y, y_image);
<a name="l00249"></a>00249     vxSetReferenceName((vx_reference)node1, <span class="stringliteral">&quot;CHANNEL_EXTRACT&quot;</span>);
<a name="l00250"></a>00250 
<a name="l00258"></a>00258     status = vxVerifyGraph(graph);
<a name="l00268"></a>00268     <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
<a name="l00278"></a>00278     <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node0);
<a name="l00279"></a>00279     <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node1);
<a name="l00282"></a>00282     <span class="keywordflow">if</span>(status==VX_SUCCESS)
<a name="l00283"></a>00283     {
<a name="l00284"></a>00284         printf(<span class="stringliteral">&quot; Executing graph ...\n&quot;</span>);
<a name="l00285"></a>00285 
<a name="l00294"></a>00294         vxScheduleGraph(graph);
<a name="l00303"></a>00303         vxWaitGraph(graph);
<a name="l00306"></a>00306         printf(<span class="stringliteral">&quot; Executing graph ... Done !!!\n&quot;</span>);
<a name="l00307"></a>00307 
<a name="l00315"></a>00315         <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(graph);
<a name="l00325"></a>00325         <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node0);
<a name="l00326"></a>00326         <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(node1);
<a name="l00329"></a>00329         printf(<span class="stringliteral">&quot; Saving to file %s ...\n&quot;</span>, <a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>);
<a name="l00330"></a>00330 
<a name="l00339"></a>00339         <a class="code" href="utility_8h.html#a2ffb77a8e510c0236b07306d0eb47a30" title="Save data from image object to BMP file.">save_image_to_file</a>(<a class="code" href="vx__tutorial__image__load__save_8c.html#a75506823f0db0ef3f4f022cf132dbbbb" title="Output file name.">OUT_FILE_NAME</a>, y_image);
<a name="l00341"></a>00341     }
<a name="l00342"></a>00342 
<a name="l00349"></a>00349     vxReleaseImage(&amp;rgb_image);
<a name="l00350"></a>00350     vxReleaseImage(&amp;nv12_image);
<a name="l00351"></a>00351     vxReleaseImage(&amp;y_image);
<a name="l00360"></a>00360     vxReleaseNode(&amp;node0);
<a name="l00361"></a>00361     vxReleaseNode(&amp;node1);
<a name="l00370"></a>00370     vxReleaseGraph(&amp;graph);
<a name="l00381"></a>00381     vxReleaseContext(&amp;context);
<a name="l00384"></a>00384     printf(<span class="stringliteral">&quot; vx_tutorial_image_color_convert: Tutorial Done !!! \n&quot;</span>);
<a name="l00385"></a>00385     printf(<span class="stringliteral">&quot; \n&quot;</span>);
<a name="l00386"></a>00386 }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="preprocessor">#define MAX_ATTRIBUTE_NAME (32u)</span>
<a name="l00389"></a>00389 <span class="preprocessor"></span>
<a name="l00399"></a><a class="code" href="vx__tutorial__image__color__convert_8c.html#a86ae0d04d187710cc2d10f85bccb6e5d">00399</a> <span class="keywordtype">void</span> <a class="code" href="utility_8h.html#a86ae0d04d187710cc2d10f85bccb6e5d" title="Show attributes of previously created graph.">show_graph_attributes</a>(vx_graph graph)
<a name="l00400"></a>00400 {
<a name="l00401"></a>00401     vx_uint32 num_nodes=0, num_params=0, ref_count=0;
<a name="l00402"></a>00402     vx_enum state=0;
<a name="l00403"></a>00403     vx_perf_t perf={0};
<a name="l00404"></a>00404     vx_char *ref_name=NULL;
<a name="l00405"></a>00405     <span class="keywordtype">char</span> ref_name_invalid[MAX_ATTRIBUTE_NAME];
<a name="l00406"></a>00406     <span class="keywordtype">char</span> state_name[MAX_ATTRIBUTE_NAME];
<a name="l00407"></a>00407 
<a name="l00414"></a>00414     vxQueryGraph(graph, VX_GRAPH_NUMNODES, &amp;num_nodes, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00415"></a>00415     vxQueryGraph(graph, VX_GRAPH_NUMPARAMETERS, &amp;num_params, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00416"></a>00416     vxQueryGraph(graph, VX_GRAPH_STATE, &amp;state, <span class="keyword">sizeof</span>(vx_enum));
<a name="l00417"></a>00417     vxQueryGraph(graph, VX_GRAPH_PERFORMANCE, &amp;perf, <span class="keyword">sizeof</span>(vx_perf_t));
<a name="l00420"></a>00420     vxQueryReference((vx_reference)graph, VX_REFERENCE_NAME, &amp;ref_name, <span class="keyword">sizeof</span>(vx_char*));
<a name="l00421"></a>00421     vxQueryReference((vx_reference)graph, VX_REFERENCE_COUNT, &amp;ref_count, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00422"></a>00422 
<a name="l00423"></a>00423     <span class="keywordflow">switch</span>(state)
<a name="l00424"></a>00424     {
<a name="l00425"></a>00425         <span class="keywordflow">case</span> VX_GRAPH_STATE_UNVERIFIED:
<a name="l00426"></a>00426             strncpy(state_name, <span class="stringliteral">&quot;VX_GRAPH_STATE_UNVERIFIED&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00427"></a>00427             <span class="keywordflow">break</span>;
<a name="l00428"></a>00428         <span class="keywordflow">case</span> VX_GRAPH_STATE_VERIFIED:
<a name="l00429"></a>00429             strncpy(state_name, <span class="stringliteral">&quot;VX_GRAPH_STATE_VERIFIED&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00430"></a>00430             <span class="keywordflow">break</span>;
<a name="l00431"></a>00431         <span class="keywordflow">case</span> VX_GRAPH_STATE_RUNNING:
<a name="l00432"></a>00432             strncpy(state_name, <span class="stringliteral">&quot;VX_GRAPH_STATE_RUNNING&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00433"></a>00433             <span class="keywordflow">break</span>;
<a name="l00434"></a>00434         <span class="keywordflow">case</span> VX_GRAPH_STATE_ABANDONED:
<a name="l00435"></a>00435             strncpy(state_name, <span class="stringliteral">&quot;VX_GRAPH_STATE_ABANDONED&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00436"></a>00436             <span class="keywordflow">break</span>;
<a name="l00437"></a>00437         <span class="keywordflow">case</span> VX_GRAPH_STATE_COMPLETED:
<a name="l00438"></a>00438             strncpy(state_name, <span class="stringliteral">&quot;VX_GRAPH_STATE_COMPLETED&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00439"></a>00439             <span class="keywordflow">break</span>;
<a name="l00440"></a>00440         <span class="keywordflow">default</span>:
<a name="l00441"></a>00441             strncpy(state_name, <span class="stringliteral">&quot;VX_GRAPH_STATE_UNKNOWN&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00442"></a>00442             <span class="keywordflow">break</span>;
<a name="l00443"></a>00443     }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445     <span class="keywordflow">if</span>(ref_name==NULL)
<a name="l00446"></a>00446     {
<a name="l00447"></a>00447         strncpy(ref_name_invalid, <span class="stringliteral">&quot;INVALID_REF_NAME&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00448"></a>00448         ref_name = &amp;ref_name_invalid[0];
<a name="l00449"></a>00449     }
<a name="l00450"></a>00450 
<a name="l00451"></a>00451     printf(<span class="stringliteral">&quot; VX_TYPE_GRAPH: %s, %d nodes, %s, avg perf %9.6fs, %d parameters, %d refs\n&quot;</span>,
<a name="l00452"></a>00452         ref_name,
<a name="l00453"></a>00453         num_nodes,
<a name="l00454"></a>00454         state_name,
<a name="l00455"></a>00455         perf.avg/1000000000.0,
<a name="l00456"></a>00456         num_params,
<a name="l00457"></a>00457         ref_count
<a name="l00458"></a>00458         );
<a name="l00459"></a>00459 }
<a name="l00460"></a>00460 
<a name="l00470"></a><a class="code" href="vx__tutorial__image__color__convert_8c.html#a4576aae15198e9645228f21be4290cff">00470</a> <span class="keywordtype">void</span> <a class="code" href="utility_8h.html#a4576aae15198e9645228f21be4290cff" title="Show attributes of previously created node.">show_node_attributes</a>(vx_node node)
<a name="l00471"></a>00471 {
<a name="l00472"></a>00472     vx_uint32 num_params=0, ref_count=0;
<a name="l00473"></a>00473     vx_status status=VX_FAILURE;
<a name="l00474"></a>00474     vx_perf_t perf={0};
<a name="l00475"></a>00475     vx_char *ref_name=NULL;
<a name="l00476"></a>00476     <span class="keywordtype">char</span> ref_name_invalid[MAX_ATTRIBUTE_NAME];
<a name="l00477"></a>00477     <span class="keywordtype">char</span> status_name[MAX_ATTRIBUTE_NAME];
<a name="l00478"></a>00478 
<a name="l00485"></a>00485     vxQueryNode(node, VX_NODE_STATUS, &amp;status, <span class="keyword">sizeof</span>(vx_status));
<a name="l00486"></a>00486     vxQueryNode(node, VX_NODE_PARAMETERS, &amp;num_params, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00487"></a>00487     vxQueryNode(node, VX_NODE_PERFORMANCE, &amp;perf, <span class="keyword">sizeof</span>(vx_perf_t));
<a name="l00490"></a>00490     vxQueryReference((vx_reference)node, VX_REFERENCE_NAME, &amp;ref_name, <span class="keyword">sizeof</span>(vx_char*));
<a name="l00491"></a>00491     vxQueryReference((vx_reference)node, VX_REFERENCE_COUNT, &amp;ref_count, <span class="keyword">sizeof</span>(vx_uint32));
<a name="l00492"></a>00492 
<a name="l00493"></a>00493     <span class="keywordflow">switch</span>(status)
<a name="l00494"></a>00494     {
<a name="l00495"></a>00495         <span class="keywordflow">case</span> VX_SUCCESS:
<a name="l00496"></a>00496             strncpy(status_name, <span class="stringliteral">&quot;VX_SUCCESS&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00497"></a>00497             <span class="keywordflow">break</span>;
<a name="l00498"></a>00498         <span class="keywordflow">case</span> VX_FAILURE:
<a name="l00499"></a>00499             strncpy(status_name, <span class="stringliteral">&quot;VX_FAILURE&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00500"></a>00500             <span class="keywordflow">break</span>;
<a name="l00501"></a>00501         <span class="keywordflow">default</span>:
<a name="l00502"></a>00502             strncpy(status_name, <span class="stringliteral">&quot;VX_FAILURE_OTHER&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00503"></a>00503             <span class="keywordflow">break</span>;
<a name="l00504"></a>00504     }
<a name="l00505"></a>00505 
<a name="l00506"></a>00506     <span class="keywordflow">if</span>(ref_name==NULL)
<a name="l00507"></a>00507     {
<a name="l00508"></a>00508         strncpy(ref_name_invalid, <span class="stringliteral">&quot;INVALID_REF_NAME&quot;</span>, MAX_ATTRIBUTE_NAME);
<a name="l00509"></a>00509         ref_name = &amp;ref_name_invalid[0];
<a name="l00510"></a>00510     }
<a name="l00511"></a>00511 
<a name="l00512"></a>00512     printf(<span class="stringliteral">&quot; VX_TYPE_NODE: %s, %d params, avg perf %9.6fs, %s, %d refs\n&quot;</span>,
<a name="l00513"></a>00513         ref_name,
<a name="l00514"></a>00514         num_params,
<a name="l00515"></a>00515         perf.avg/1000000000.0,
<a name="l00516"></a>00516         status_name,
<a name="l00517"></a>00517         ref_count
<a name="l00518"></a>00518         );
<a name="l00519"></a>00519 }
</pre></div></div>

<html>
<table bordercolor="#FFFFFF" bgcolor="#FFFFFF" width="100%">
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF">
        <hr align="left" noshade size="1">
      </td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000"><b><i>
        &copy Copyright 2017 Texas Instruments Incorporated. All rights reserved. </i></b></font></td>
</tr>
<tr bgcolor="#CCCCCC">
      <td bgcolor="#FFFFFF"><font face="Verdana, Arial, Helvetica, sans-serif" size="1" color="#000000">
        Document generated by <b><i> doxygen </i></b> 1.6.1
  </font></td>
</tr>
</table>
